#include "stdafx.h"
#include "trayiconprocessingwnd.h"


CTrayIconProcessingWnd::CTrayIconProcessingWnd()
{
	m_bHappy=TRUE;

	m_hIcons[0] = m_trayIcon.LoadIconResource(IDR_HAPPY);
	m_hIcons[1] = m_trayIcon.LoadIconResource(IDR_SAD);

}

LRESULT CTrayIconProcessingWnd::OnCreate(UINT /*uMsg*/,WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{

	m_trayIcon.Create(this, IDR_TRAYPOPUP, _T("Demo Tray Application"), m_hIcons, 2, 500, WM_TRAYNOTIFY);

	m_trayIcon.SetDefaultMenuItem(ID_APP_EXIT);
	bHandled=TRUE;
	return 0L;
}

HWND CTrayIconProcessingWnd::Create()
{
	RECT rc;
	memset(&rc,0,sizeof(RECT));
	return CWindowImpl<CTrayIconProcessingWnd>::Create(NULL,rc,_T("CTrayIconProcessingWnd Notification Window"),WS_OVERLAPPEDWINDOW,0,0);
}

LRESULT CTrayIconProcessingWnd::OnTrayNotification(UINT /*uMsg*/,WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled=TRUE;
	return !m_trayIcon.OnTrayNotification(wParam,lParam); // invert the output
}

LRESULT CTrayIconProcessingWnd::OnExit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& bHandled)
{
	PostMessage(WM_QUIT);
	bHandled=TRUE;
	return 0L;
}

LRESULT CTrayIconProcessingWnd::OnUpdateHappy(WORD /*wNotifyCode*/, WORD wID, HMENU hMenu, BOOL& bHandled)
{
	MENUITEMINFO mi;

	::ZeroMemory(&mi,sizeof(MENUITEMINFO));

	mi.cbSize=sizeof(MENUITEMINFO);
	mi.fMask=MIIM_STATE;
	if (m_trayIcon.UsingAnimatedIcon())
		mi.fState=MFS_DISABLED | MFS_GRAYED;
	else
		mi.fState=(m_bHappy)? MFS_CHECKED:MFS_UNCHECKED;

	SetMenuItemInfo(hMenu,wID,FALSE,&mi);
	

	bHandled=TRUE;
	return 0L;
}

LRESULT CTrayIconProcessingWnd::OnHappy(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& bHandled)
{
	if (m_bHappy)
		return 0L;

	m_bHappy = !m_bHappy;
	
	m_trayIcon.SetIcon(IDR_HAPPY);
	m_trayIcon.SetTooltipText(_T("I'm Happy!"));

	bHandled=TRUE;
	return 0L;
}

LRESULT CTrayIconProcessingWnd::OnUpdateSad(WORD /*wNotifyCode*/, WORD wID, HMENU hMenu, BOOL& bHandled)
{
	MENUITEMINFO mi;

	::ZeroMemory(&mi,sizeof(MENUITEMINFO));

	mi.cbSize=sizeof(MENUITEMINFO);
	mi.fMask=MIIM_STATE;
	if (m_trayIcon.UsingAnimatedIcon())
		mi.fState=MFS_DISABLED | MFS_GRAYED;
	else
		mi.fState=(!m_bHappy)? MFS_CHECKED:MFS_UNCHECKED;

	SetMenuItemInfo(hMenu,wID,FALSE,&mi);

	bHandled=TRUE;
	return 0L;
}

LRESULT CTrayIconProcessingWnd::OnSad(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& bHandled)
{
	if (!m_bHappy)
		return 0L;

	m_bHappy = !m_bHappy;

	m_trayIcon.SetIcon(IDR_SAD);
	m_trayIcon.SetTooltipText(_T("I'm Sad!"));

	bHandled=TRUE;
	return 0L;
}

LRESULT CTrayIconProcessingWnd::OnUpdateAnimate(WORD /*wNotifyCode*/, WORD wID, HMENU hMenu, BOOL& bHandled)
{
	MENUITEMINFO mi;

	::ZeroMemory(&mi,sizeof(MENUITEMINFO));

	mi.cbSize=sizeof(MENUITEMINFO);
	mi.fMask=MIIM_STATE;
	mi.fState=(m_trayIcon.UsingAnimatedIcon())? MFS_CHECKED:MFS_UNCHECKED;

	SetMenuItemInfo(hMenu,wID,FALSE,&mi);

	bHandled=TRUE;
	return 0L;
}

LRESULT CTrayIconProcessingWnd::OnAnimate(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& bHandled)
{
	
	if (m_trayIcon.UsingAnimatedIcon())
	{
		if (m_bHappy)
		{
			m_trayIcon.SetTooltipText(_T("I'm Happy"));
			m_trayIcon.SetIcon(m_hIcons[0]);
		}
		else
		{
			m_trayIcon.SetTooltipText(_T("I'm Sad"));
			m_trayIcon.SetIcon(m_hIcons[1]);
		}

	}
	else
	{
		m_trayIcon.SetIcon(m_hIcons, 2, 500);
		m_trayIcon.SetTooltipText(_T("I'm Animating!"));
	}

	bHandled=TRUE;
	return 0L;
}




