#ifndef TrayIconProcessingWnd
#define TrayIconProcessingWnd 1

#include "ntray.h"

#include "resource.h"

#define WM_TRAYNOTIFY WM_USER + 100

class CTrayIconProcessingWnd : public CWindowImpl<CTrayIconProcessingWnd>
{
public:
	CTrayIconProcessingWnd();

public:
	HWND Create();

protected:
	BEGIN_MSG_MAP(CTrayIconProcessingWnd)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_TRAYNOTIFY, OnTrayNotification)
		COMMAND_HANDLER(ID_APP_EXIT, 0, OnExit)
		COMMAND_HANDLER(ID_HAPPY, 0, OnHappy)
		COMMAND_HANDLER(ID_SAD, 0, OnSad)
		COMMAND_HANDLER(ID_ANIMATED, 0, OnAnimate)
		MENU_UPDATE_COMMAND_HANDLER(ID_HAPPY, OnUpdateHappy)
		MENU_UPDATE_COMMAND_HANDLER(ID_SAD, OnUpdateSad)
		MENU_UPDATE_COMMAND_HANDLER(ID_ANIMATED, OnUpdateAnimate)
	END_MSG_MAP()

	// MessageHandler
	LRESULT OnCreate(UINT uMsg,WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnTrayNotification(UINT uMsg,WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	// CommandHandler
	LRESULT OnExit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnHappy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnSad(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnAnimate(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

	LRESULT OnUpdateHappy(WORD wNotifyCode, WORD wID, HMENU hMenu, BOOL& bHandled);
	LRESULT OnUpdateSad(WORD wNotifyCode, WORD wID, HMENU hMenu, BOOL& bHandled);
	LRESULT OnUpdateAnimate(WORD wNotifyCode, WORD wID, HMENU hMenu, BOOL& bHandled);

	CTrayNotifyIcon m_trayIcon;
	HICON m_hIcons[2];
	BOOL m_bHappy;

	friend class CMyTrayIcon;

};

#endif //TrayIconProcessingWnd